Name: openvswitch
Summary: Virtual switch
Group: System Environment/Daemons
URL: http://www.openvswitch.org/
Version: 2.1.3
License: ASL 2.0 and GPLv2
Release: 13.7579
Source: %{name}-%{version}.tar.gz
Group: Applications/System
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

%define kernel_version 3.10.0+2

%description
The vswitch provides standard network bridging functions augmented with
support for the OpenFlow protocol for remote per-flow control of
traffic.

%prep
%setup -n %{name}-%{version}

%build
%configure --enable-ssl --without-pcre --without-ncurses --with-logdir=/var/log --with-linux=/lib/modules/%{kernel_version}/build

%{__make} %{_smp_mflags}

%install
rm -rf %{buildroot}
%makeinstall
%{__make} INSTALL_MOD_PATH=%{buildroot} modules_install

install -d -m 755 $RPM_BUILD_ROOT/var/lib/openvswitch
install -d -m 755 $RPM_BUILD_ROOT/var/log/openvswitch
install -d -m 755 $RPM_BUILD_ROOT/var/xen/openvswitch

install -d -m 755 $RPM_BUILD_ROOT/%{_sysconfdir}/openvswitch

install -d -m 755 $RPM_BUILD_ROOT/%{_sysconfdir}/init.d
install -m 755 xenserver/etc_init.d_openvswitch \
         $RPM_BUILD_ROOT/%{_sysconfdir}/init.d/openvswitch

install -d -m 755 $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig
install -m 755 xenserver/usr_share_openvswitch_scripts_sysconfig.template \
         $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/openvswitch

install -d -m 755 $RPM_BUILD_ROOT/%{_sysconfdir}/logrotate.d
install -m 755 xenserver/etc_logrotate.d_openvswitch \
         $RPM_BUILD_ROOT/%{_sysconfdir}/logrotate.d/openvswitch

install -d -m 755 $RPM_BUILD_ROOT/%{_sysconfdir}/xapi.d/plugins
install -m 755 xenserver/etc_xapi.d_plugins_openvswitch-cfg-update \
         $RPM_BUILD_ROOT/%{_sysconfdir}/xapi.d/plugins/openvswitch-cfg-update

install -d -m 755 $RPM_BUILD_ROOT/%{_datadir}/openvswitch
install -m 644 vswitchd/vswitch.ovsschema \
         $RPM_BUILD_ROOT/%{_datadir}/openvswitch/vswitch.ovsschema

install -m 755 xenserver/usr_share_openvswitch_scripts_ovs-xapi-sync \
         $RPM_BUILD_ROOT/%{_datadir}/openvswitch/scripts/ovs-xapi-sync

install -d -m 755 $RPM_BUILD_ROOT/%{_libdir}/xsconsole/plugins-base
install -m 644 xenserver/usr_lib_xsconsole_plugins-base_XSFeatureVSwitch.py \
         $RPM_BUILD_ROOT/%{_libdir}/xsconsole/plugins-base/XSFeatureVSwitch.py

	 
install python/compat/uuid.py $RPM_BUILD_ROOT/%{_datadir}/openvswitch/python
install python/compat/argparse.py $RPM_BUILD_ROOT/%{_datadir}/openvswitch/python

# mark modules executable so that strip-to-file can strip them
find $RPM_BUILD_ROOT/lib/modules/%{kernel_version} -name "*.ko" -type f | xargs chmod u+x

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc COPYING README
%config %{_sysconfdir}/init.d/openvswitch
%config %{_sysconfdir}/sysconfig/openvswitch
%config %{_sysconfdir}/logrotate.d/openvswitch
%{_sysconfdir}/xapi.d/plugins/openvswitch-cfg-update
%dir /etc/openvswitch
%dir /var/xen/openvswitch
%dir /var/lib/openvswitch
%dir /var/log/openvswitch
%{_bindir}/ovs-benchmark
%{_bindir}/ovs-appctl
%{_bindir}/ovs-dpctl
%{_bindir}/ovs-dpctl-top
%{_bindir}/ovs-ofctl
%{_bindir}/ovs-pcap
%{_bindir}/ovs-tcpundump
%{_bindir}/ovs-vlan-test
%{_bindir}/ovs-vsctl
%{_bindir}/ovsdb-client
%{_bindir}/ovsdb-tool
%{_bindir}/ovs-test
%{_sbindir}/ovs-bugtool
%{_sbindir}/ovs-vswitchd
%{_sbindir}/ovsdb-server
%{_datadir}/openvswitch/bugtool-plugins/kernel-info/openvswitch.xml
%{_datadir}/openvswitch/bugtool-plugins/network-status/openvswitch.xml
%{_datadir}/openvswitch/bugtool-plugins/system-configuration.xml
%{_datadir}/openvswitch/bugtool-plugins/system-configuration/openvswitch.xml
%{_datadir}/openvswitch/bugtool-plugins/system-logs/openvswitch.xml
%{_datadir}/openvswitch/python/ovs/__init__.py*
%{_datadir}/openvswitch/python/ovs/daemon.py*
%{_datadir}/openvswitch/python/ovs/db/__init__.py*
%{_datadir}/openvswitch/python/ovs/db/data.py*
%{_datadir}/openvswitch/python/ovs/db/error.py*
%{_datadir}/openvswitch/python/ovs/db/idl.py*
%{_datadir}/openvswitch/python/ovs/db/parser.py*
%{_datadir}/openvswitch/python/ovs/db/schema.py*
%{_datadir}/openvswitch/python/ovs/db/types.py*
%{_datadir}/openvswitch/python/ovs/unixctl/__init__.py*
%{_datadir}/openvswitch/python/ovs/unixctl/client.py*
%{_datadir}/openvswitch/python/ovs/unixctl/server.py*
%{_datadir}/openvswitch/python/ovs/dirs.py*
%{_datadir}/openvswitch/python/ovs/fatal_signal.py*
%{_datadir}/openvswitch/python/ovs/json.py*
%{_datadir}/openvswitch/python/ovs/jsonrpc.py*
%{_datadir}/openvswitch/python/ovs/ovsuuid.py*
%{_datadir}/openvswitch/python/ovs/poller.py*
%{_datadir}/openvswitch/python/ovs/process.py*
%{_datadir}/openvswitch/python/ovs/reconnect.py*
%{_datadir}/openvswitch/python/ovs/socket_util.py*
%{_datadir}/openvswitch/python/ovs/stream.py*
%{_datadir}/openvswitch/python/ovs/timeval.py*
%{_datadir}/openvswitch/python/ovs/util.py*
%{_datadir}/openvswitch/python/ovs/vlog.py*
%{_datadir}/openvswitch/python/ovs/version.py*
%{_datadir}/openvswitch/python/argparse.py*
%{_datadir}/openvswitch/python/uuid.py*
%{_datadir}/openvswitch/vswitch.ovsschema
%{_datadir}/openvswitch/scripts/ovs-lib
%{_datadir}/openvswitch/scripts/ovs-bugtool-*
%{_datadir}/openvswitch/scripts/ovs-ctl
%{_datadir}/openvswitch/scripts/ovs-save
%{_datadir}/openvswitch/scripts/ovs-xapi-sync
%{_mandir}/man1/ovsdb-client.1.gz
%{_mandir}/man1/ovsdb-tool.1.gz
%{_mandir}/man1/ovsdb-server.1.gz
%{_mandir}/man5/ovs-vswitchd.conf.db.5.gz
%{_mandir}/man8/ovs-appctl.8.gz
%{_mandir}/man8/ovs-dpctl.8.gz
%{_mandir}/man8/ovs-dpctl-top.8.gz
%{_mandir}/man8/ovs-ofctl.8.gz
%{_mandir}/man1/ovs-pcap.1.gz
%{_mandir}/man1/ovs-tcpundump.1.gz
%{_mandir}/man8/ovs-vlan-test.8.gz
%{_mandir}/man8/ovs-vsctl.8.gz
%{_mandir}/man8/ovs-vswitchd.8.gz
%{_mandir}/man1/ovs-benchmark.1.gz
%{_mandir}/man8/ovs-bugtool.8.gz
%{_mandir}/man8/ovs-ctl.8.gz
%{_libdir}/xsconsole/plugins-base/

%exclude %{_bindir}/ovs-l3ping
%exclude %{_bindir}/ovs-parse-backtrace
%exclude %{_bindir}/ovs-pki
%exclude %{_sbindir}/ovs-vlan-bug-workaround
%exclude %{_mandir}/man8/ovs-l3ping.8.gz
%exclude %{_mandir}/man8/ovs-parse-backtrace.8.gz
%exclude %{_mandir}/man8/ovs-pki.8.gz
%exclude %{_mandir}/man8/ovs-test.8.gz
%exclude %{_mandir}/man8/ovs-vlan-bug-workaround.8.gz
%exclude %{_datadir}/openvswitch/python/ovstest
%exclude %{_datadir}/openvswitch/scripts/ovs-check-dead-ifs

%exclude %{_bindir}/vtep-ctl
%exclude %{_mandir}/man5/vtep.5.gz
%exclude %{_mandir}/man8/vtep-ctl.8.gz
%exclude %{_datadir}/openvswitch/scripts/ovs-vtep
%exclude %{_datadir}/openvswitch/vtep.ovsschema


%package modules
Summary: Open vSwitch kernel module
Release: %{version}
Version: %(echo "%{kernel_version}" | tr - .)
Group: System Environment/Kernel
License: GPLv2
Provides: %{name}-modules = %{kernel_version}
Requires(post): /sbin/depmod

%description modules
Open vSwitch Linux kernel module compiled against kernel version
%{kernel_version}.

%files modules
%defattr(-,root,root)
/lib/modules/%{kernel_version}/extra/*.ko
%exclude /lib/modules/%{kernel_version}/modules.*

%post modules
/sbin/depmod -a %{kernel_version}

%postun
/sbin/depmod -a %{kernel_version}


%changelog
